within ;
package kulopruz
  model eqSystem
  Real x;
  Real v;
  Real f( unit="N");
  Real a( unit="m.s-2");
  parameter Real m(unit = "kg") = 1;
  parameter Real k(unit="Pa") = 1;
  initial equation
    x = -1;
  equation

  f = m*a;
  a = der(v);
  v = der(x);

  f =  - k*x;

  end eqSystem;

  connector conxf "mechanickz konektor"
  Real x(final unit="m") "poloha";
  flow Real f(final unit="N") "sla";
    annotation (Icon(graphics={Rectangle(
            extent={{-80,80},{80,-80}},
            lineColor={0,0,255},
            fillColor={0,0,127},
            fillPattern=FillPattern.CrossDiag), Line(
            points={{-100,-100},{102,100},{-100,100},{100,-100}},
            color={0,0,255},
            smooth=Smooth.None)}));
  end conxf;

  model fix

    conxf konektor annotation (Placement(transformation(extent={{-10,-28},{10,-8}}),
          iconTransformation(extent={{-10,-28},{10,-8}})));
    annotation (Icon(graphics={Rectangle(
            extent={{-100,80},{98,-20}},
            lineColor={0,0,255},
            fillColor={85,255,255},
            fillPattern=FillPattern.Forward)}));
  equation
  konektor.x = 0;
  end fix;

  model kulicka
  Real a( unit="m.s-2");
  Real v( unit = "m.s-1");
  Real x( unit = "m");
  parameter Real m( unit="kg")= 1;
    conxf conxf1 annotation (Placement(transformation(extent={{2,-20},{22,0}}),
          iconTransformation(extent={{2,-20},{22,0}})));
    annotation (Icon(graphics={Ellipse(
            extent={{-80,80},{98,-98}},
            lineColor={0,0,255},
            fillColor={255,0,255},
            fillPattern=FillPattern.Solid)}));
  parameter Real start;
  initial equation
    start = x;
  equation
  // ke konektoru mohu pristupovat v samostatne rovnici
  conxf1.x = x;

  // nebo klidne rovnou
  conxf1.f = m*a;
  a = der(v);
  v = der(x);
  end kulicka;

  model system

    perko perko1
      annotation (Placement(transformation(extent={{-20,4},{0,24}})));
    kulicka kulicka1(m=1, start=-1)
      annotation (Placement(transformation(extent={{-20,-70},{0,-50}})));
    fix fix1 annotation (Placement(transformation(extent={{-22,50},{-2,70}})));
  equation
    // tyhle rovnice sou nagenerovany automaticky tim, ze jsem to spojil v editoru diagramu
    // bez anotaci by to taky bezelo, jen by na diagramu nebylo nic videt
    // vsimnete si, jak je to propojeny
    connect(fix1.konektor, perko1.conxf1) annotation (Line(
        points={{-12,58.2},{-12,21.6},{-10.8,21.6}},
        color={0,0,255},
        smooth=Smooth.None));
    connect(perko1.conxf2, kulicka1.conxf1) annotation (Line(
        points={{-10.2,8.6},{-10.2,-26.7},{-8.8,-26.7},{-8.8,-61}},
        color={0,0,255},
        smooth=Smooth.None));
    annotation (Diagram(graphics), Icon(graphics={Ellipse(
            extent={{-58,72},{58,-38}},
            lineColor={0,0,255},
            fillColor={255,0,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{-126,-80},{132,126}},
            lineColor={0,0,255},
            fillColor={255,0,255},
            fillPattern=FillPattern.Solid,
            textString="A")}));
  end system;

  model perko

    parameter Real k( unit = "kg.s-2")= 1 "Tuhost pruziny";
    conxf conxf1 annotation (Placement(transformation(extent={{-18,66},{2,86}})));
    conxf conxf2
      annotation (Placement(transformation(extent={{-12,-64},{8,-44}})));
    annotation (Icon(graphics={Line(
            points={{-10,66},{-38,36},{36,36},{-36,-4},{44,6},{-40,-32},{44,-22},{
                -4,-54},{-2,-54}},
            color={0,0,255},
            smooth=Smooth.None)}));
  equation
    // bacha, sice je to f = -k*x, ale je to na vytoku.
    // cili rigorozne by to mohlo byt
    // f = -k*conxf2.x;
    // conxf2.x = -f;
    // a samozrejme deklarovat si f
    conxf2.f =  k*conxf2.x;

  // kirchhof - soucet je nula, nic se nam neschova
    conxf1.f + conxf2.f = 0;
  end perko;
  annotation (uses(Modelica(version="3.2")));
end kulopruz;
